SLASH_HRA1 = "/hra"




function HRA_BuildSaveVariables()
	if HRA_settings == nil then
		HRA_settings = {}
	end
	if HRA_settings.enabled == nil then
		HRA_settings.enabled = true
	end
	if HRA_settings.debug == nil then
		HRA_settings.debug = false
	end
	if HRA_settings.interval == nil then
		HRA_settings.interval = 250
	end
	if HRA_settings.colorDepthLevels == nil then
		HRA_settings.colorDepthLevels = 1
	end
	
	if HRA_settings.rangeTOalpha == nil then
		HRA_settings.rangeTOalpha = {}
	end
	if HRA_settings.rangeTOalpha[28] == nil then
		HRA_settings.rangeTOalpha[28]=1
	end
	if HRA_settings.rangeTOalpha[100] == nil then
		HRA_settings.rangeTOalpha[100]=.5
	end
	if HRA_settings.rangeTOalpha[30000] == nil then
		HRA_settings.rangeTOalpha[30000]=.3
	end
	if HRA_settings.rangeTOalpha[0] == nil then
		HRA_settings.rangeTOalpha[0] = 1
	end
	
	
	if HRA_settings.rangeTOcolor == nil then
		HRA_settings.rangeTOcolor = {}
	end
	if HRA_settings.rangeTOcolor[28] == nil then
		HRA_settings.rangeTOcolor[28]={r=1,g=1,b=1,opacity=0}
	end
	if HRA_settings.rangeTOcolor[100] == nil then
		HRA_settings.rangeTOcolor[100]={r=0,g=.7,b=1,opacity=.7}
	end
	if HRA_settings.rangeTOcolor[30000] == nil then
		HRA_settings.rangeTOcolor[30000]={r=0,g=0,b=1,opacity=.7}
	end
	if HRA_settings.rangeTOcolor[0] == nil then
		HRA_settings.rangeTOcolor[0] = {r=1,g=1,b=1,opacity=0}
	end
end


function HRA_defaults()
	if HRA_settings == nil then
		HRA_settings = {}
	end
	HRA_settings.enabled = true
	HRA_settings.debug = false
	HRA_settings.interval = 250
	HRA_settings.colorDepthLevels = 1
	if HRA_settings.rangeTOalpha == nil then
		HRA_settings.rangeTOalpha = {}
	end
	HRA_settings.rangeTOalpha[28]=1
	HRA_settings.rangeTOalpha[100]=.5
	HRA_settings.rangeTOalpha[30000]=.3
	HRA_settings.rangeTOalpha[0] = 1
	if HRA_settings.rangeTOcolor == nil then
		HRA_settings.rangeTOcolor = {}
	end
	HRA_settings.rangeTOcolor[28]={r=1,g=1,b=1,opacity=0}
	HRA_settings.rangeTOcolor[100]={r=0,g=.7,b=1,opacity=.7}
	HRA_settings.rangeTOcolor[30000]={r=0,g=0,b=1,opacity=.7}
	HRA_settings.rangeTOcolor[0]={r=1,g=1,b=1,opacity=0}
end

function HRA_PrintTable(t)
	for k,v in pairs(t) do
		DEFAULT_CHAT_FRAME:AddMessage(v,0,1,.5)
	end
end

function HRA_PrintObject(t)
	if type(t) == "string" or type(t) == "number" then
		DEFAULT_CHAT_FRAME:AddMessage(t,0,1,.5)
	end
	if type(t) == "table" then
		for k,v in pairs(t) do
			if type(v) == "string" or type(v) == "number" then
				DEFAULT_CHAT_FRAME:AddMessage(k..": "..v,0,1,.5)
			end
		end
	end
end

---------------------------
--[[  local variables  ]]--
---------------------------
local version = "4.10"
local lasttime = 0
local unitframes = {}
local updateframes = GetTime()
local rangeTOspells = {}
local spellcount = 0
local queue_frame_update = GetTime()

local unitstoscan = {"player","target"}

-- vertex color texture
--local temptexture
-- comparsion color
local comparecolor = {}

--
local last_frames = 0
local last_textures = 0


-- Binding Variables
BINDING_HEADER_HRA = "Healing Range Alpha";
BINDING_NAME_HRA = "Enable/Disable";

local unitrange = {}
local queue = {}

function HRA_OnCommand(cmd)
	HRA_Print("HealingRangeAlpha v"..version,0,1,.5)
	HRAOptionFrame:Show()
end

local frame = getglobal("HRAFrame")

SlashCmdList["HRA"] = HRA_OnCommand;
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("VARIABLES_LOADED")
frame:RegisterEvent("PLAYER_LOGIN")
frame:RegisterEvent("PARTY_MEMBERS_CHANGED")
frame:RegisterEvent("RAID_ROSTER_UPDATE")
frame:RegisterEvent("SPELLS_CHANGED")


--------------------
--[[  OnUpdate  ]]--
--------------------
function HRA_OnUpdate(elapsed)
	if queue_frame_update ~= 0 and queue_frame_update + 5 < GetTime() then
		queue_frame_update = 0
		find_frames()
	end
	
	--restrict checks
	if not HRA_settings.enabled or lasttime+HRA_settings.interval/1000 > GetTime() then
		return
	end
	lasttime = GetTime()
	
	--[[
	HRA_ScanUnit("player")
	HRA_ScanUnit("target")
	HRA_ScanUnit("targettarget")
	HRA_ScanUnit("targettargettarget")
	HRA_ScanUnit("focus")
	for i=1,GetNumRaidMembers() do
		HRA_ScanUnit("raid"..i)
	end
	for i=1,GetNumPartyMembers() do
		HRA_ScanUnit("party"..i)
	end
	for i=1,GetNumPartyMembers() do
		HRA_ScanUnit("party"..i.."pet")
	end]]
	
	for k,v in pairs(unitframes) do
		if not HRA_ExistsInTable(unitstoscan,v.frame:GetAttribute("unit")) then
			table.insert(unitstoscan,v.frame:GetAttribute("unit"))
		end
	end
	
	for k,v in pairs(unitstoscan) do
		HRA_ScanUnit(v)
	end
	
	HRA_UpdateFrames()
end

--frame:SetScript("OnUpdate",HRA_OnUpdate)

unitframes = {}


--[[
local junkframe = CreateFrame("Button",nil,UIParent,SecureUnitButtonTemplate)
local oldSetAlpha = getmetatable(junkframe).__index.SetAlpha

getmetatable(junkframe).__index.SetAlpha = function(ob,alpha,...)
	if ob:GetAttribute("unit") then
		oldSetAlpha(ob,HRA_settings.rangeTOalpha[unitrange[ob:GetAttribute("unit")] ] or alpha)
	else
		oldSetAlpha(ob,alpha,...)
	end
end]]

local index = getmetatable(frame).__index;

local oldSetAlpha = index.SetAlpha

index.SetAlpha = function(object,alpha,...)
	if object:GetAttribute("unit") then
		HRA_SetFrameAlpha(object)
	else
		oldSetAlpha(object,alpha,...)
	end
end

hooksecurefunc(index, "Show", function(object, attribute, ...)
	if object:GetAttribute("unit") then
		HRA_SetFrameAlpha(object)
	end
end)

--[[
for k,v in pairs(index) do
	hooksecurefunc(index, k, function(object, arg1, ...)
		if k == "GetAlpha" then
			return
		end
		if not object.hra_alpha then
			object.hra_alpha = object:GetAlpha()
			--Print("Setting initial value on "..(object:GetName() or "frame").." with value: "..object:GetAlpha())
		end
		if not object.hra_alpha or object.hra_alpha ~= object:GetAlpha() then
			object.hra_alpha = object:GetAlpha()
			--Print("alpha change on "..(object:GetName() or "frame").." from function "..k.." with value: "..object:GetAlpha())
		end
	end)
end]]

--getmetatable(frame).__index.SetAlpha(object,alpha,...)

--[[
local oldSetAttribute = index.SetAttribute
function index.SetAttribute(object,attribute,unitid,...)
	oldSetAttribute(object,attribute,unitid,...)
	--HRA_PrintObject(object)
	--HRA_PrintObject(attribute)
	--HRA_PrintObject(unitid)
	--Print("yes")
	if string.lower(attribute) == "unit" then
		Print("unit")
		if not HRA_ExistsInTable(unitstoscan,unitid) then
			table.insert(unitstoscan,unitid)
			HRA_PrintTable(unitstoscan)
		end
	end
end]]

function HRA_ExistsInTable(t,value,subtable)
	for k,v in pairs(t) do
		if subtable and value == v[subtable] then
			return true
		elseif value == v then
			return true
		end
	end
	return false
end


-- Collect any newly created frames
hooksecurefunc("CreateFrame",function(frameType,frameName,parentFrame, inheritedFrame, ...)
	if inheritedFrame then
		queue_frame_update = GetTime()
	end
end)

--[[
function(frameType,frameName,parentFrame, inheritedFrame, ...)

	if inheritedFrame and ReturnedValue:IsProtected() then
		if getmetatable(ReturnedValue).__index.SetAttribute then
			table.insert(unitframes,{frame=ReturnedValue}) --,vertex=HRA_FindVertexTextures(temp)})
		end
	end
end)]]
--[[
local oldCreateFrame = CreateFrame
CreateFrame = function(frameType,frameName,parentFrame, inheritedFrame, ...)
	local temp = oldCreateFrame(frameType,frameName,parentFrame, inheritedFrame, ...)
	if inheritedFrame and temp:IsProtected() then
		if getmetatable(temp).__index.SetAttribute then
			table.insert(unitframes,{frame=temp}) --,vertex=HRA_FindVertexTextures(temp)})
			
			--temp:SetScript("OnAttributeChanged",function()
			--	if arg1 == "unit" or arg2 == "unit" then Print(arg1.." "..arg2.." "..(arg3 or "")) error ("here",1) end end)
			--if temp:GetAttribute("unit") and not HRA_ExistsInTable(unitstoscan,temp:GetAttribute("unit")) then
			--	table.insert(unitstoscan,temp:GetAttribute("unit"))
			--	HRA_PrintTable(unitstoscan)
			--end
		end
	end
	return temp
end]]


function find_frames()
	-- Find any preexisting frames
	local frame = EnumerateFrames()
	while frame do
		if --[[frame:GetObjectType() == "Button" and ]]frame:IsProtected() then
			if getmetatable(frame).__index.SetAttribute then --and frame:GetAttribute("unit") then
			
				if frame:GetAttribute("unit") and not HRA_ExistsInTable(unitframes,frame,"frame") then
					table.insert(unitframes,{frame=frame}) --,vertex=HRA_FindVertexTextures(frame)})
					--[[
					frame.hra_oldscript = frame:GetScript("OnAttributeChanged")
					frame:SetScript("OnAttributeChanged",function()
						if this.hra_oldscript then
							this.hra_oldscript()
						end
						if string.find(arg1,"unit") then
							Print("arg1: "..arg1.."    arg2: "..(arg2 or "--"))
						end
					end)]]
					--[[
					frame:HookScript("OnAttributeChanged",function()
						if string.find(arg1,"unit") then
							Print("arg1: "..arg1.."    arg2: "..(arg2 or "--"))
						end
					end)]]
				end
				
				if frame:GetAttribute("unit") and not HRA_ExistsInTable(unitstoscan,frame:GetAttribute("unit")) then
					table.insert(unitstoscan,frame:GetAttribute("unit"))
					--HRA_PrintTable(unitstoscan)
				end
			end
			
			--[[
			if frame.HRArangetext == nil and (string.find(frame:GetAttribute("unit"),"party") or frame:GetAttribute("unit")=="target") then
				frame.HRArangetext = frame:CreateFontString(nil,"ARTWORK")
				frame.HRArangetext:SetFont("Fonts\\ARIALN.TTF",10)
				frame.HRArangetext:SetPoint("BOTTOMRIGHT",frame,"TOPRIGHT",0,0)
			end]]
			
			--[[frame.HRA_textures = {}
			if HRA_settings.colorDepthLevels > 0 then
				HRA_ChildBranches(frame,frame.HRA_textures,HRA_GetTexture,1,HRA_settings.colorDepthLevels,frame:GetAttribute("unit"))
			end]]
		end
		frame = EnumerateFrames(frame)
	end
end


function HRA_GetTexture(object)
	if object:GetObjectType() == "Button" then
		return object:GetNormalTexture()
	elseif object:GetObjectType() == "StatusBar" then
		return object:GetStatusBarTexture()
	elseif object:GetObjectType() == "Texture" then
		return object:GetTexture()
	end
	return nil
end

function HRA_FindFriendlySpells()

	rangeTOspells = {}
	spellcount = ({GetSpellTabInfo(GetNumSpellTabs())})[3]+({GetSpellTabInfo(GetNumSpellTabs())})[4]
	
	
	local name,tab
	for i=1,spellcount do
		name = GetSpellName(i, "BOOKTYPE_SPELL")
		if IsSpellInRange(name, "player") == 1 then
			HRATooltip:ClearLines()
			HRATooltip:SetOwner(this, "ANCHOR_NONE")
			HRATooltip:SetSpell(i,"BOOKTYPE_SPELL")
			tab = getglobal("HRATooltipTextRight2")
			if not tab:IsShown() then
				tab = getglobal("HRATooltipTextLeft2")
			end
			if tab:IsShown() then
				tab = ({string.find(tab:GetText(),"(%d+) yd range")})[3]
				tab = tonumber(tab)
				
				-- check if party only spell
				local party = 0
				for j=4,HRATooltip:NumLines() do
					if string.find(getglobal("HRATooltipTextLeft"..j):GetText(),"party") then
						party = 1
					end
				end
				
				if party == 0 and tab and rangeTOspells[tab] == nil and tab < 100 then
					rangeTOspells[tab] = name
					
					if HRA_settings.rangeTOalpha[tab] == nil then
						HRA_settings.rangeTOalpha[tab]=1
					end
					if HRA_settings.rangeTOcolor[tab] == nil then
						HRA_settings.rangeTOcolor[tab]={r=1,g=1,b=1,opacity=0}
						if tab >= 40 then
							HRA_settings.rangeTOcolor[tab]={r=0,g=1,b=1,opacity=.7}
						end
					end
				end
			end
		end
	end
	
	HRA_Print("HRA - Spell list updated",0,1,.5)
end

function HRA_UpdateFrames()
	for i=1,table.getn(unitframes) do
		HRA_SetFrameAlpha(unitframes[i].frame)
	end
end

function HRA_SetFrameAlpha(frame)
	-- only change frames with unit values
	if frame:GetAttribute("unit") then
		if unitrange[frame:GetAttribute("unit")] and UnitIsFriend(frame:GetAttribute("unit"),"player") then
		
			if HRA_settings.rangeTOalpha[unitrange[frame:GetAttribute("unit")]] then
				oldSetAlpha(frame,HRA_settings.rangeTOalpha[unitrange[frame:GetAttribute("unit")]]  ) --or 1)
			end
			
			--for k,v in ipairs(unitframes[i].HRA_textures) do
			--	HRA_VerticeColors(v,HRA_settings.rangeTOcolor[unitrange[unitframes[i]:GetAttribute("unit")]],unitrange[unitframes[i]:GetAttribute("unit")])
			--end
		else
			oldSetAlpha(frame,HRA_settings.rangeTOalpha[0])
			
			--for k,v in ipairs(unitframes[i].HRA_textures) do
			--	HRA_VerticeColors(v,HRA_settings.rangeTOcolor[0],0)
			--end
		end
		return true
	end
	return nil
end

function HRA_ChildBranches(object,list,objectfunc,currentlevel,maxlevel,unitid)
	
	if objectfunc(object) then
		table.insert(list,{texture=objectfunc(object),unitid=unitid})
	end
	
	if currentlevel < maxlevel then
		local kids = { object:GetChildren() }
		for _,child in ipairs(kids) do
			HRA_ChildBranches(child,list,objectfunc,currentlevel+1,maxlevel,unitid)
		end
	end
end

function HRA_FindVertexTextures(frame)
	local list = {}
	table.insert(list,HRA_GetTexture(frame))
	local kids = { frame:GetChildren() }
	for _,child in ipairs(kids) do
		table.insert(list,HRA_GetTexture(child))
	end
	return list
end

function HRA_VerticeColors(textureobject,color,range)

	if color == nil then
		return
	end
	-- check for original colors
	if textureobject.HRAoriginal == nil then
		textureobject.HRAoriginal = {}
		textureobject.HRAoriginal[1],textureobject.HRAoriginal[2],textureobject.HRAoriginal[3],textureobject.HRAoriginal[4] = textureobject.texture:GetVertexColor()
		textureobject.HRAmodified = {0,0,0,0}
		textureobject.HRAunitname = UnitName(textureobject.unitid)
	end
	
	--comparecolor = {textureobject.texture:GetVertexColor()}
	comparecolor[1],comparecolor[2],comparecolor[3],comparecolor[4] = textureobject.texture:GetVertexColor()
	
	-- New target selected (colors changed and either range stays the same or name changed)
	if textureobject.HRAmodified[1] ~= comparecolor[1] or textureobject.HRAmodified[2] ~= comparecolor[2] or textureobject.HRAmodified[3] ~= comparecolor[3] then
		if textureobject.HRArange == range or textureobject.HRAunitname ~= UnitName(textureobject.unitid) then
			textureobject.HRAoriginal[1] = comparecolor[1]
			textureobject.HRAoriginal[2] = comparecolor[2]
			textureobject.HRAoriginal[3] = comparecolor[3]
			textureobject.HRAoriginal[4] = comparecolor[4]
			
			textureobject.HRAmodified[1] = textureobject.HRAoriginal[1]*(1-color.opacity) + color.r*color.opacity
			textureobject.HRAmodified[2] = textureobject.HRAoriginal[2]*(1-color.opacity) + color.g*color.opacity
			textureobject.HRAmodified[3] = textureobject.HRAoriginal[3]*(1-color.opacity) + color.b*color.opacity
			textureobject.HRAmodified[4] = textureobject.HRAoriginal[4]
			
			textureobject.texture:SetVertexColor(textureobject.HRAmodified[1], textureobject.HRAmodified[2], textureobject.HRAmodified[3], textureobject.HRAmodified[4])
			
			textureobject.HRAunitname = UnitName(textureobject.unitid)
			textureobject.HRArange = range
			
			--textureobject.HRAmodified = {textureobject.texture:GetVertexColor()}
			textureobject.HRAmodified[1],textureobject.HRAmodified[2],textureobject.HRAmodified[3],textureobject.HRAmodified[4] = textureobject.texture:GetVertexColor()
		end
	end
	
	if textureobject.HRArange ~= range then
		textureobject.HRAmodified[1] = textureobject.HRAoriginal[1]*(1-color.opacity) + color.r*color.opacity
		textureobject.HRAmodified[2] = textureobject.HRAoriginal[2]*(1-color.opacity) + color.g*color.opacity
		textureobject.HRAmodified[3] = textureobject.HRAoriginal[3]*(1-color.opacity) + color.b*color.opacity
		textureobject.HRAmodified[4] = textureobject.HRAoriginal[4]
		
		textureobject.texture:SetVertexColor(textureobject.HRAmodified[1], textureobject.HRAmodified[2], textureobject.HRAmodified[3], textureobject.HRAmodified[4])
		--textureobject.HRAmodified = {textureobject.texture:GetVertexColor()}
		textureobject.HRAmodified[1],textureobject.HRAmodified[2],textureobject.HRAmodified[3],textureobject.HRAmodified[4] = textureobject.texture:GetVertexColor()
		
		textureobject.HRArange = range
	end
end

function HRA_AllFramesFullAlpha()
	for i=1,table.getn(unitframes) do
		unitframes[i].frame:SetAlpha(1)
		--for k,v in ipairs(unitframes[i].HRA_textures) do
		--	if v.HRAoriginal then
		--		v.texture:SetVertexColor(v.HRAoriginal[1], v.HRAoriginal[2], v.HRAoriginal[3], v.HRAoriginal[4])
		--	end
		--	v.HRAoriginal = nil
		--end
	end
end

function HRA_ScanUnit(unitid)
	-- not visible
	unitrange[unitid]=100
	
	if not UnitIsVisible(unitid) then
		unitrange[unitid]=30000
		return
	end
	
	if CheckInteractDistance(unitid, 4) then
		unitrange[unitid]=28
		return
	end
	
	for range,spell in pairs(rangeTOspells) do
		if IsSpellInRange(spell,unitid) == 1 then
		   
			if unitrange[unitid] > range then
				unitrange[unitid] = range
			end
		end
	end
	
end

-------------------
--[[  OnEvent  ]]--
-------------------
function HRA_OnEvent(event)
	if (event == "ADDON_LOADED") then
		if (arg1 == "HealingRangeAlpha") then
			DEFAULT_CHAT_FRAME:AddMessage("HealingRangeAlpha loaded",0,1,.5)
		end
	end
	
	if event == "VARIABLES_LOADED" then
		HRA_BuildSaveVariables()
	end
	if event == "PLAYER_LOGIN" then
		HRA_FindFriendlySpells()
		HRA_removeRanges()
		for range,alpha in pairs(HRA_settings.rangeTOalpha) do
			range = tonumber(range)
			if range == 0 then
				--Ignore  (full alpha and default 
			elseif range == 30000 then
				HRA_insertRange("Out of sight",range,alpha)
			elseif range == 100 then
				HRA_insertRange("Within sight",range,alpha)
			elseif range == 28 then
				HRA_insertRange("28 yards (Autofollow Interaction)",range,alpha)
			else
				if rangeTOspells[range] then
					HRA_insertRange(range.." yards ("..rangeTOspells[range]..")",range,alpha)
				end
			end
		end
		HRA_sortRanges()
	end
	if event == "SPELLS_CHANGED" then
		if spellcount ~= ({GetSpellTabInfo(GetNumSpellTabs())})[3]+({GetSpellTabInfo(GetNumSpellTabs())})[4] then
			HRA_FindFriendlySpells()
		end
	end
	if event == "PARTY_MEMBERS_CHANGED" or event == "RAID_ROSTER_UPDATE" then
		updateframes = GetTime()
	end
end

function HRA_ApplyChanges()

	HRA_settings.enabled = HRAOptionFrameEnableCheck:GetChecked()
	HRA_settings.debug = HRAOptionFrameDebugCheck:GetChecked()
	
	if tonumber(HRAOptionFrameIntervalEdit:GetText()) then
		HRA_settings.interval = tonumber(HRAOptionFrameIntervalEdit:GetText())
	else
		HRA_settings.interval = 0
	end
	if tonumber(HRAOptionFrameDepthEdit:GetText()) then
		HRA_settings.colorDepthLevels = tonumber(HRAOptionFrameDepthEdit:GetText())
	else
		HRA_settings.colorDepthLevels = 0
	end
	
	local slider
	for i=1,10 do
		slider = getglobal("HRAOptionFrameRangeSlider"..i)
		if slider == nil then
			break
		end
		HRA_settings.rangeTOalpha[slider.range] = slider:GetValue()
		HRA_settings.rangeTOcolor[slider.range] = HRAGetButtonColor(slider.color)
	end
	--HRA_FindUnitFrames()
	
	if not HRA_settings.enabled then
		HRA_AllFramesFullAlpha()
	end
end



function HRA_LoadSettings()
	HRAOptionFrameEnableCheck:SetChecked(HRA_settings.enabled)
	HRAOptionFrameDebugCheck:SetChecked(HRA_settings.debug)
	
	HRAOptionFrameIntervalEdit:SetText(HRA_settings.interval)
	HRAOptionFrameDepthEdit:SetText(HRA_settings.colorDepthLevels)
	
	local slider
	for i=1,10 do
		slider = getglobal("HRAOptionFrameRangeSlider"..i)
		if slider == nil then
			break
		end
		slider:SetValue(HRA_settings.rangeTOalpha[slider.range])
		HRASetButtonColor(slider.color,HRA_settings.rangeTOcolor[slider.range])
	end
end

function HRA_Print(text)
	if HRA_settings.debug then
		DEFAULT_CHAT_FRAME:AddMessage(text,0,1,.5)
	end
end

function HRA_PrintTable(t)
	if HRA_settings.debug then
		for k,v in pairs(t) do
			DEFAULT_CHAT_FRAME:AddMessage(v,0,1,.5)
		end
	end
end